require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SPARC_BITOPS_H)) {
    eval 'sub _SPARC_BITOPS_H () {1;}' unless defined(&_SPARC_BITOPS_H);
    require 'linux/compiler.ph';
    require 'asm/byteorder.ph';
    if(defined(&__KERNEL__)) {
	eval 'sub set_bit {
	    my($nr,$addr) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&set_bit);
	eval 'sub test_and_clear_bit {
	    my($nr,$addr) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&test_and_clear_bit);
	eval 'sub clear_bit {
	    my($nr,$addr) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&clear_bit);
	eval 'sub test_and_change_bit {
	    my($nr,$addr) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&test_and_change_bit);
	eval 'sub change_bit {
	    my($nr,$addr) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&change_bit);
	eval 'sub __clear_bit {
	    my($nr,$addr) = @_;
    	    eval q({ my $mask = 1 << ($nr & 0x1f); my $long * &p = ($addr) + ($nr >> 5); * &p &= ~ $mask; });
	}' unless defined(&__clear_bit);
	eval 'sub __change_bit {
	    my($nr,$addr) = @_;
    	    eval q({ my $mask = 1 << ($nr & 0x1f); my $long * &p = ($addr) + ($nr >> 5); * &p ^=  $mask; });
	}' unless defined(&__change_bit);
	eval 'sub __test_and_set_bit {
	    my($nr,$addr) = @_;
    	    eval q({ my $mask = 1 << ($nr & 0x1f); my $long * &p = ($addr) + ($nr >> 5); my $old = * &p; * &p =  $old |  $mask; ( $old &  $mask) != 0; });
	}' unless defined(&__test_and_set_bit);
	eval 'sub __test_and_clear_bit {
	    my($nr,$addr) = @_;
    	    eval q({ my $mask = 1 << ($nr & 0x1f); my $long * &p = ($addr) + ($nr >> 5); my $old = * &p; * &p =  $old & ~ $mask; ( $old &  $mask) != 0; });
	}' unless defined(&__test_and_clear_bit);
	eval 'sub __test_and_change_bit {
	    my($nr,$addr) = @_;
    	    eval q({ my $mask = 1 << ($nr & 0x1f); my $long * &p = ($addr) + ($nr >> 5); my $old = * &p; * &p =  $old ^  $mask; ( $old &  $mask) != 0; });
	}' unless defined(&__test_and_change_bit);
	eval 'sub smp_mb__before_clear_bit () {
	    eval q( &do { }  &while(0));
	}' unless defined(&smp_mb__before_clear_bit);
	eval 'sub smp_mb__after_clear_bit () {
	    eval q( &do { }  &while(0));
	}' unless defined(&smp_mb__after_clear_bit);
	eval 'sub fls {
	    my($x) = @_;
    	    eval q( &generic_fls($x));
	}' unless defined(&fls);
	eval 'sub hweight32 {
	    my($x) = @_;
    	    eval q( &generic_hweight32($x));
	}' unless defined(&hweight32);
	eval 'sub hweight16 {
	    my($x) = @_;
    	    eval q( &generic_hweight16($x));
	}' unless defined(&hweight16);
	eval 'sub hweight8 {
	    my($x) = @_;
    	    eval q( &generic_hweight8($x));
	}' unless defined(&hweight8);
	eval 'sub find_first_zero_bit {
	    my($addr, $size) = @_;
    	    eval q( &find_next_zero_bit(($addr), ($size), 0));
	}' unless defined(&find_first_zero_bit);
	eval 'sub find_first_bit {
	    my($addr, $size) = @_;
    	    eval q( &find_next_bit(($addr), ($size), 0));
	}' unless defined(&find_first_bit);
	eval 'sub __clear_le_bit {
	    my($nr,$addr) = @_;
    	    eval q({ my $char * &ADDR = $addr;  &ADDR += $nr >> 3; * &ADDR &= ~(1<< ($nr & 0x7)); });
	}' unless defined(&__clear_le_bit);
	eval 'sub __test_and_set_le_bit {
	    my($nr,$addr) = @_;
    	    eval q({ \'int\'  &mask,  &retval; my $char * &ADDR = $addr;  &ADDR += $nr >> 3;  &mask = 1<< ($nr & 0x7);  &retval = ( &mask & * &ADDR) != 0; * &ADDR |=  &mask;  &retval; });
	}' unless defined(&__test_and_set_le_bit);
	eval 'sub __test_and_clear_le_bit {
	    my($nr,$addr) = @_;
    	    eval q({ \'int\'  &mask,  &retval; my $char * &ADDR = $addr;  &ADDR += $nr >> 3;  &mask = 1<< ($nr & 0x7);  &retval = ( &mask & * &ADDR) != 0; * &ADDR &= ~ &mask;  &retval; });
	}' unless defined(&__test_and_clear_le_bit);
	eval 'sub find_next_zero_le_bit {
	    my($addr,$size,$offset) = @_;
    	    eval q({  &const my $long * &p = $addr + ($offset >> 5); my $result = $offset & ~31; my $tmp;  &if ($offset >= $size) $size; $size -=  $result; $offset &= 31;  &if($offset) {  $tmp = *( &p++);  $tmp |=  &__swab32(~0 >> (32-$offset));  &if($size < 32)  &goto  &found_first;  &if(~ $tmp)  &goto  &found_middle; $size -= 32;  $result += 32; }  &while($size & ~31) {  &if(~( $tmp = *( &p++)))  &goto  &found_middle;  $result += 32; $size -= 32; }  &if(!$size)  $result;  $tmp = * &p;  &found_first:  $tmp =  &__swab32( $tmp) | (~0 << $size);  &if ( $tmp == ~0)  $result + $size;  $result +  &ffz( $tmp);  &found_middle:  $result +  &ffz( &__swab32( $tmp)); });
	}' unless defined(&find_next_zero_le_bit);
	eval 'sub find_first_zero_le_bit {
	    my($addr, $size) = @_;
    	    eval q( &find_next_zero_le_bit(($addr), ($size), 0));
	}' unless defined(&find_first_zero_le_bit);
	eval 'sub ext2_set_bit {
	    my($nr,$addr) = @_;
    	    eval q( &__test_and_set_le_bit(,($addr)));
	}' unless defined(&ext2_set_bit);
	eval 'sub ext2_clear_bit {
	    my($nr,$addr) = @_;
    	    eval q( &__test_and_clear_le_bit(,($addr)));
	}' unless defined(&ext2_clear_bit);
	eval 'sub ext2_set_bit_atomic {
	    my($lock, $nr, $addr) = @_;
    	    eval q(({ \'int\'  &ret;  &spin_lock;  &ret =  &ext2_set_bit(, ($addr));  &spin_unlock($lock);  &ret; }));
	}' unless defined(&ext2_set_bit_atomic);
	eval 'sub ext2_clear_bit_atomic {
	    my($lock, $nr, $addr) = @_;
    	    eval q(({ \'int\'  &ret;  &spin_lock;  &ret =  &ext2_clear_bit(, ($addr));  &spin_unlock($lock);  &ret; }));
	}' unless defined(&ext2_clear_bit_atomic);
	eval 'sub ext2_test_bit {
	    my($nr,$addr) = @_;
    	    eval q( &test_le_bit(,($addr)));
	}' unless defined(&ext2_test_bit);
	eval 'sub ext2_find_first_zero_bit {
	    my($addr, $size) = @_;
    	    eval q( &find_first_zero_le_bit(($addr), ($size)));
	}' unless defined(&ext2_find_first_zero_bit);
	eval 'sub ext2_find_next_zero_bit {
	    my($addr, $size, $off) = @_;
    	    eval q( &find_next_zero_le_bit(($addr), ($size), ($off)));
	}' unless defined(&ext2_find_next_zero_bit);
	eval 'sub minix_test_and_set_bit {
	    my($nr,$addr) = @_;
    	    eval q( &test_and_set_bit(,($addr)));
	}' unless defined(&minix_test_and_set_bit);
	eval 'sub minix_set_bit {
	    my($nr,$addr) = @_;
    	    eval q( &set_bit(,($addr)));
	}' unless defined(&minix_set_bit);
	eval 'sub minix_test_and_clear_bit {
	    my($nr,$addr) = @_;
    	    eval q( &test_and_clear_bit(,($addr)));
	}' unless defined(&minix_test_and_clear_bit);
	eval 'sub minix_test_bit {
	    my($nr,$addr) = @_;
    	    eval q( &test_bit(,($addr)));
	}' unless defined(&minix_test_bit);
	eval 'sub minix_find_first_zero_bit {
	    my($addr,$size) = @_;
    	    eval q( &find_first_zero_bit(($addr),($size)));
	}' unless defined(&minix_find_first_zero_bit);
    }
}
1;
