require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__SPARC_SPINLOCK_H)) {
    eval 'sub __SPARC_SPINLOCK_H () {1;}' unless defined(&__SPARC_SPINLOCK_H);
    require 'linux/threads.ph';
    unless(defined(&__ASSEMBLY__)) {
	require 'asm/psr.ph';
	if(defined(&CONFIG_DEBUG_SPINLOCK)) {
	    if(defined(&CONFIG_PREEMPT)) {
	    }
	    eval 'sub SPIN_LOCK_UNLOCKED () {( &spinlock_t) { 0, 0};}' unless defined(&SPIN_LOCK_UNLOCKED);
	    eval 'sub spin_lock_init {
	        my($lp) = @_;
    		eval q( &do { *($lp)=  &SPIN_LOCK_UNLOCKED; }  &while(0));
	    }' unless defined(&spin_lock_init);
	    eval 'sub spin_is_locked {
	        my($lp) = @_;
    		eval q((*(( &volatile \'unsigned char\' *)((($lp)-> &lock))) != 0));
	    }' unless defined(&spin_is_locked);
	    eval 'sub spin_unlock_wait {
	        my($lp) = @_;
    		eval q( &do {  &barrier(); }  &while(*( &volatile \'unsigned char\' *)(($lp)-> &lock)));
	    }' unless defined(&spin_unlock_wait);
	    eval 'sub _raw_spin_trylock {
	        my($lp) = @_;
    		eval q( &_spin_trylock($lp));
	    }' unless defined(&_raw_spin_trylock);
	    eval 'sub _raw_spin_lock {
	        my($lock) = @_;
    		eval q( &_do_spin_lock($lock, \\"spin_lock\\"));
	    }' unless defined(&_raw_spin_lock);
	    eval 'sub _raw_spin_unlock {
	        my($lock) = @_;
    		eval q( &_do_spin_unlock($lock));
	    }' unless defined(&_raw_spin_unlock);
	    if(defined(&CONFIG_PREEMPT)) {
	    }
	    eval 'sub RW_LOCK_UNLOCKED () {( &rwlock_t) { 0, 0, {0} };}' unless defined(&RW_LOCK_UNLOCKED);
	    eval 'sub rwlock_init {
	        my($lp) = @_;
    		eval q( &do { *($lp)=  &RW_LOCK_UNLOCKED; }  &while(0));
	    }' unless defined(&rwlock_init);
	    eval 'sub _raw_read_lock {
	        my($lock) = @_;
    		eval q( &do { \'unsigned long flags\';  &local_irq_save( &flags);  &_do_read_lock($lock, \\"read_lock\\");  &local_irq_restore( &flags); }  &while(0));
	    }' unless defined(&_raw_read_lock);
	    eval 'sub _raw_read_unlock {
	        my($lock) = @_;
    		eval q( &do { \'unsigned long flags\';  &local_irq_save( &flags);  &_do_read_unlock($lock, \\"read_unlock\\");  &local_irq_restore( &flags); }  &while(0));
	    }' unless defined(&_raw_read_unlock);
	    eval 'sub _raw_write_lock {
	        my($lock) = @_;
    		eval q( &do { \'unsigned long flags\';  &local_irq_save( &flags);  &_do_write_lock($lock, \\"write_lock\\");  &local_irq_restore( &flags); }  &while(0));
	    }' unless defined(&_raw_write_lock);
	    eval 'sub _raw_write_unlock {
	        my($lock) = @_;
    		eval q( &do { \'unsigned long flags\';  &local_irq_save( &flags);  &_do_write_unlock($lock);  &local_irq_restore( &flags); }  &while(0));
	    }' unless defined(&_raw_write_unlock);
	} else {
	    if(defined(&CONFIG_PREEMPT)) {
	    }
	    eval 'sub SPIN_LOCK_UNLOCKED () {( &spinlock_t) { 0};}' unless defined(&SPIN_LOCK_UNLOCKED);
	    eval 'sub spin_lock_init {
	        my($lock) = @_;
    		eval q((*(($lock)) = 0));
	    }' unless defined(&spin_lock_init);
	    eval 'sub spin_is_locked {
	        my($lock) = @_;
    		eval q((*(( &volatile \'unsigned char\' *)($lock)) != 0));
	    }' unless defined(&spin_is_locked);
	    eval 'sub spin_unlock_wait {
	        my($lock) = @_;
    		eval q( &do {  &barrier(); }  &while(*(( &volatile \'unsigned char\' *)$lock)));
	    }' unless defined(&spin_unlock_wait);
	    eval 'sub _raw_spin_lock {
	        my($lock) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&_raw_spin_lock);
	    eval 'sub _raw_spin_trylock {
	        my($lock) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&_raw_spin_trylock);
	    eval 'sub _raw_spin_unlock {
	        my($lock) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&_raw_spin_unlock);
	    if(defined(&CONFIG_PREEMPT)) {
	    }
	    eval 'sub RW_LOCK_UNLOCKED () {( &rwlock_t) { 0};}' unless defined(&RW_LOCK_UNLOCKED);
	    eval 'sub rwlock_init {
	        my($lp) = @_;
    		eval q( &do { *($lp)=  &RW_LOCK_UNLOCKED; }  &while(0));
	    }' unless defined(&rwlock_init);
	    eval 'sub _raw_read_lock {
	        my($lock) = @_;
    		eval q( &do { \'unsigned long flags\';  &local_irq_save( &flags);  &_read_lock($lock);  &local_irq_restore( &flags); }  &while(0));
	    }' unless defined(&_raw_read_lock);
	    eval 'sub _read_unlock {
	        my($rw) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&_read_unlock);
	    eval 'sub _raw_read_unlock {
	        my($lock) = @_;
    		eval q( &do { \'unsigned long flags\';  &local_irq_save( &flags);  &_read_unlock($lock);  &local_irq_restore( &flags); }  &while(0));
	    }' unless defined(&_raw_read_unlock);
	    eval 'sub _raw_write_lock {
	        my($rw) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&_raw_write_lock);
	    eval 'sub _raw_write_unlock {
	        my($rw) = @_;
    		eval q( &do { ($rw)-> &lock = 0; }  &while(0));
	    }' unless defined(&_raw_write_unlock);
	}
	eval 'sub _raw_spin_lock_flags {
	    my($lock, $flags) = @_;
    	    eval q( &_raw_spin_lock($lock));
	}' unless defined(&_raw_spin_lock_flags);
    }
}
1;
