require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SPARC64_BITOPS_H)) {
    eval 'sub _SPARC64_BITOPS_H () {1;}' unless defined(&_SPARC64_BITOPS_H);
    require 'linux/config.ph';
    require 'linux/compiler.ph';
    require 'asm/byteorder.ph';
    eval 'sub __clear_bit {
        my($nr,$addr) = @_;
	    eval q({  &volatile my $long * &m = $addr + ($nr >> 6); * &m &= ~(1 << ($nr & 63)); });
    }' unless defined(&__clear_bit);
    eval 'sub __change_bit {
        my($nr,$addr) = @_;
	    eval q({  &volatile my $long * &m = $addr + ($nr >> 6); * &m ^= (1 << ($nr & 63)); });
    }' unless defined(&__change_bit);
    eval 'sub __test_and_set_bit {
        my($nr,$addr) = @_;
	    eval q({  &volatile my $long * &m = $addr + ($nr >> 6); my $old = * &m; my $mask = (1 << ($nr & 63)); * &m = ( $old |  $mask); (( $old &  $mask) != 0); });
    }' unless defined(&__test_and_set_bit);
    eval 'sub __test_and_clear_bit {
        my($nr,$addr) = @_;
	    eval q({  &volatile my $long * &m = $addr + ($nr >> 6); my $old = * &m; my $mask = (1 << ($nr & 63)); * &m = ( $old & ~ $mask); (( $old &  $mask) != 0); });
    }' unless defined(&__test_and_clear_bit);
    eval 'sub __test_and_change_bit {
        my($nr,$addr) = @_;
	    eval q({  &volatile my $long * &m = $addr + ($nr >> 6); my $old = * &m; my $mask = (1 << ($nr & 63)); * &m = ( $old ^  $mask); (( $old &  $mask) != 0); });
    }' unless defined(&__test_and_change_bit);
    if(defined(&CONFIG_SMP)) {
	eval 'sub smp_mb__before_clear_bit () {
	    eval q( &membar(\\"#StoreLoad | #LoadLoad\\"));
	}' unless defined(&smp_mb__before_clear_bit);
	eval 'sub smp_mb__after_clear_bit () {
	    eval q( &membar(\\"#StoreLoad | #StoreStore\\"));
	}' unless defined(&smp_mb__after_clear_bit);
    } else {
	eval 'sub smp_mb__before_clear_bit () {
	    eval q( &barrier());
	}' unless defined(&smp_mb__before_clear_bit);
	eval 'sub smp_mb__after_clear_bit () {
	    eval q( &barrier());
	}' unless defined(&smp_mb__after_clear_bit);
    }
    eval 'sub test_bit {
        my($nr,$addr) = @_;
	    eval q({ (1 & (($addr)[$nr >> 6] >> ($nr & 63))) != 0; });
    }' unless defined(&test_bit);
    eval 'sub fls {
        my($x) = @_;
	    eval q( &generic_fls($x));
    }' unless defined(&fls);
    if(defined(&__KERNEL__)) {
	if(defined(&ULTRA_HAS_POPULATION_COUNT)) {
	    eval 'sub hweight64 {
	        my($w) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&hweight64);
	    eval 'sub hweight32 {
	        my($w) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&hweight32);
	    eval 'sub hweight16 {
	        my($w) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&hweight16);
	    eval 'sub hweight8 {
	        my($w) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&hweight8);
	} else {
	    eval 'sub hweight64 {
	        my($x) = @_;
    		eval q( &generic_hweight64($x));
	    }' unless defined(&hweight64);
	    eval 'sub hweight32 {
	        my($x) = @_;
    		eval q( &generic_hweight32($x));
	    }' unless defined(&hweight32);
	    eval 'sub hweight16 {
	        my($x) = @_;
    		eval q( &generic_hweight16($x));
	    }' unless defined(&hweight16);
	    eval 'sub hweight8 {
	        my($x) = @_;
    		eval q( &generic_hweight8($x));
	    }' unless defined(&hweight8);
	}
    }
    eval 'sub find_first_bit {
        my($addr, $size) = @_;
	    eval q( &find_next_bit(($addr), ($size), 0));
    }' unless defined(&find_first_bit);
    eval 'sub find_first_zero_bit {
        my($addr, $size) = @_;
	    eval q( &find_next_zero_bit(($addr), ($size), 0));
    }' unless defined(&find_first_zero_bit);
    eval 'sub test_and_set_le_bit {
        my($nr,$addr) = @_;
	    eval q( &test_and_set_bit(($nr) ^ 0x38, ($addr)));
    }' unless defined(&test_and_set_le_bit);
    eval 'sub test_and_clear_le_bit {
        my($nr,$addr) = @_;
	    eval q( &test_and_clear_bit(($nr) ^ 0x38, ($addr)));
    }' unless defined(&test_and_clear_le_bit);
    eval 'sub test_le_bit {
        my($nr,$addr) = @_;
	    eval q({ \'int\'  &mask;  &__const__ my $char * &ADDR = ( &__const__ my $char *) $addr;  &ADDR += $nr >> 3;  &mask = 1<< ($nr & 0x7); (( &mask & * &ADDR) != 0); });
    }' unless defined(&test_le_bit);
    eval 'sub find_first_zero_le_bit {
        my($addr, $size) = @_;
	    eval q( &find_next_zero_le_bit(($addr), ($size), 0));
    }' unless defined(&find_first_zero_le_bit);
    if(defined(&__KERNEL__)) {
	eval 'sub __set_le_bit {
	    my($nr, $addr) = @_;
    	    eval q( &__set_bit(($nr) ^ 0x38, ($addr)));
	}' unless defined(&__set_le_bit);
	eval 'sub __clear_le_bit {
	    my($nr, $addr) = @_;
    	    eval q( &__clear_bit(($nr) ^ 0x38, ($addr)));
	}' unless defined(&__clear_le_bit);
	eval 'sub __test_and_clear_le_bit {
	    my($nr, $addr) = @_;
    	    eval q( &__test_and_clear_bit(($nr) ^ 0x38, ($addr)));
	}' unless defined(&__test_and_clear_le_bit);
	eval 'sub __test_and_set_le_bit {
	    my($nr, $addr) = @_;
    	    eval q( &__test_and_set_bit(($nr) ^ 0x38, ($addr)));
	}' unless defined(&__test_and_set_le_bit);
	eval 'sub ext2_set_bit {
	    my($nr,$addr) = @_;
    	    eval q( &__test_and_set_le_bit(,($addr)));
	}' unless defined(&ext2_set_bit);
	eval 'sub ext2_set_bit_atomic {
	    my($lock,$nr,$addr) = @_;
    	    eval q( &test_and_set_le_bit(,($addr)));
	}' unless defined(&ext2_set_bit_atomic);
	eval 'sub ext2_clear_bit {
	    my($nr,$addr) = @_;
    	    eval q( &__test_and_clear_le_bit(,($addr)));
	}' unless defined(&ext2_clear_bit);
	eval 'sub ext2_clear_bit_atomic {
	    my($lock,$nr,$addr) = @_;
    	    eval q( &test_and_clear_le_bit(,($addr)));
	}' unless defined(&ext2_clear_bit_atomic);
	eval 'sub ext2_test_bit {
	    my($nr,$addr) = @_;
    	    eval q( &test_le_bit(,($addr)));
	}' unless defined(&ext2_test_bit);
	eval 'sub ext2_find_first_zero_bit {
	    my($addr, $size) = @_;
    	    eval q( &find_first_zero_le_bit(($addr), ($size)));
	}' unless defined(&ext2_find_first_zero_bit);
	eval 'sub ext2_find_next_zero_bit {
	    my($addr, $size, $off) = @_;
    	    eval q( &find_next_zero_le_bit(($addr), ($size), ($off)));
	}' unless defined(&ext2_find_next_zero_bit);
	eval 'sub minix_test_and_set_bit {
	    my($nr,$addr) = @_;
    	    eval q( &test_and_set_bit(,($addr)));
	}' unless defined(&minix_test_and_set_bit);
	eval 'sub minix_set_bit {
	    my($nr,$addr) = @_;
    	    eval q( &set_bit(,($addr)));
	}' unless defined(&minix_set_bit);
	eval 'sub minix_test_and_clear_bit {
	    my($nr,$addr) = @_;
    	    eval q( &test_and_clear_bit(,($addr)));
	}' unless defined(&minix_test_and_clear_bit);
	eval 'sub minix_test_bit {
	    my($nr,$addr) = @_;
    	    eval q( &test_bit(,($addr)));
	}' unless defined(&minix_test_bit);
	eval 'sub minix_find_first_zero_bit {
	    my($addr,$size) = @_;
    	    eval q( &find_first_zero_bit(($addr),($size)));
	}' unless defined(&minix_find_first_zero_bit);
    }
}
1;
