require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__SPARC64_SPINLOCK_H)) {
    eval 'sub __SPARC64_SPINLOCK_H () {1;}' unless defined(&__SPARC64_SPINLOCK_H);
    require 'linux/config.ph';
    require 'linux/threads.ph';
    unless(defined(&__ASSEMBLY__)) {
	unless(defined(&CONFIG_DEBUG_SPINLOCK)) {
	    if(defined(&CONFIG_PREEMPT)) {
	    }
	    eval 'sub SPIN_LOCK_UNLOCKED () {( &spinlock_t) {0,};}' unless defined(&SPIN_LOCK_UNLOCKED);
	    eval 'sub spin_lock_init {
	        my($lp) = @_;
    		eval q( &do { *($lp)=  &SPIN_LOCK_UNLOCKED; }  &while(0));
	    }' unless defined(&spin_lock_init);
	    eval 'sub spin_is_locked {
	        my($lp) = @_;
    		eval q((($lp)-> &lock != 0));
	    }' unless defined(&spin_is_locked);
	    eval 'sub spin_unlock_wait {
	        my($lp) = @_;
    		eval q( &do {  &membar(\\"#LoadLoad\\"); }  &while(($lp)-> &lock));
	    }' unless defined(&spin_unlock_wait);
	    eval 'sub _raw_spin_lock {
	        my($lock) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&_raw_spin_lock);
	    eval 'sub _raw_spin_trylock {
	        my($lock) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&_raw_spin_trylock);
	    eval 'sub _raw_spin_unlock {
	        my($lock) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&_raw_spin_unlock);
	    eval 'sub _raw_spin_lock_flags {
	        my($lock,$flags) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&_raw_spin_lock_flags);
	} else {
	    if(defined(&CONFIG_PREEMPT)) {
	    }
	    eval 'sub SPIN_LOCK_UNLOCKED () {( &spinlock_t) { 0, 0, 0xff };}' unless defined(&SPIN_LOCK_UNLOCKED);
	    eval 'sub spin_lock_init {
	        my($lp) = @_;
    		eval q( &do { *($lp)=  &SPIN_LOCK_UNLOCKED; }  &while(0));
	    }' unless defined(&spin_lock_init);
	    eval 'sub spin_is_locked {
	        my($__lock) = @_;
    		eval q((($__lock)-> &lock != 0));
	    }' unless defined(&spin_is_locked);
	    eval 'sub spin_unlock_wait {
	        my($__lock) = @_;
    		eval q( &do {  &membar(\\"#LoadLoad\\"); }  &while(($__lock)-> &lock));
	    }' unless defined(&spin_unlock_wait);
	    eval 'sub _raw_spin_trylock {
	        my($lp) = @_;
    		eval q( &_do_spin_trylock($lp));
	    }' unless defined(&_raw_spin_trylock);
	    eval 'sub _raw_spin_lock {
	        my($lock) = @_;
    		eval q( &_do_spin_lock($lock, \\"spin_lock\\"));
	    }' unless defined(&_raw_spin_lock);
	    eval 'sub _raw_spin_unlock {
	        my($lock) = @_;
    		eval q( &_do_spin_unlock($lock));
	    }' unless defined(&_raw_spin_unlock);
	    eval 'sub _raw_spin_lock_flags {
	        my($lock, $flags) = @_;
    		eval q( &_raw_spin_lock($lock));
	    }' unless defined(&_raw_spin_lock_flags);
	}
	unless(defined(&CONFIG_DEBUG_SPINLOCK)) {
	    if(defined(&CONFIG_PREEMPT)) {
	    }
	    eval 'sub RW_LOCK_UNLOCKED () {( &rwlock_t) {0,};}' unless defined(&RW_LOCK_UNLOCKED);
	    eval 'sub rwlock_init {
	        my($lp) = @_;
    		eval q( &do { *($lp) =  &RW_LOCK_UNLOCKED; }  &while(0));
	    }' unless defined(&rwlock_init);
	    eval 'sub _raw_read_lock {
	        my($p) = @_;
    		eval q( &__read_lock($p));
	    }' unless defined(&_raw_read_lock);
	    eval 'sub _raw_read_unlock {
	        my($p) = @_;
    		eval q( &__read_unlock($p));
	    }' unless defined(&_raw_read_unlock);
	    eval 'sub _raw_write_lock {
	        my($p) = @_;
    		eval q( &__write_lock($p));
	    }' unless defined(&_raw_write_lock);
	    eval 'sub _raw_write_unlock {
	        my($p) = @_;
    		eval q( &__write_unlock($p));
	    }' unless defined(&_raw_write_unlock);
	    eval 'sub _raw_write_trylock {
	        my($p) = @_;
    		eval q( &__write_trylock($p));
	    }' unless defined(&_raw_write_trylock);
	} else {
	    if(defined(&CONFIG_PREEMPT)) {
	    }
	    eval 'sub RW_LOCK_UNLOCKED () {( &rwlock_t) { 0, 0, 0xff, { } };}' unless defined(&RW_LOCK_UNLOCKED);
	    eval 'sub rwlock_init {
	        my($lp) = @_;
    		eval q( &do { *($lp) =  &RW_LOCK_UNLOCKED; }  &while(0));
	    }' unless defined(&rwlock_init);
	    eval 'sub _raw_read_lock {
	        my($lock) = @_;
    		eval q( &do { \'unsigned long flags\';  &local_irq_save( &flags);  &_do_read_lock($lock, \\"read_lock\\");  &local_irq_restore( &flags); }  &while(0));
	    }' unless defined(&_raw_read_lock);
	    eval 'sub _raw_read_unlock {
	        my($lock) = @_;
    		eval q( &do { \'unsigned long flags\';  &local_irq_save( &flags);  &_do_read_unlock($lock, \\"read_unlock\\");  &local_irq_restore( &flags); }  &while(0));
	    }' unless defined(&_raw_read_unlock);
	    eval 'sub _raw_write_lock {
	        my($lock) = @_;
    		eval q( &do { \'unsigned long flags\';  &local_irq_save( &flags);  &_do_write_lock($lock, \\"write_lock\\");  &local_irq_restore( &flags); }  &while(0));
	    }' unless defined(&_raw_write_lock);
	    eval 'sub _raw_write_unlock {
	        my($lock) = @_;
    		eval q( &do { \'unsigned long flags\';  &local_irq_save( &flags);  &_do_write_unlock($lock);  &local_irq_restore( &flags); }  &while(0));
	    }' unless defined(&_raw_write_unlock);
	    eval 'sub _raw_write_trylock {
	        my($lock) = @_;
    		eval q(({ \'unsigned long flags\'; \'int\'  &val;  &local_irq_save( &flags);  &val =  &_do_write_trylock($lock, \\"write_trylock\\");  &local_irq_restore( &flags);  &val; }));
	    }' unless defined(&_raw_write_trylock);
	}
	eval 'sub _raw_read_trylock {
	    my($lock) = @_;
    	    eval q( &generic_raw_read_trylock($lock));
	}' unless defined(&_raw_read_trylock);
	eval 'sub read_can_lock {
	    my($rw) = @_;
    	    eval q((!(($rw)-> &lock & 0x80000000)));
	}' unless defined(&read_can_lock);
	eval 'sub write_can_lock {
	    my($rw) = @_;
    	    eval q((!($rw)-> &lock));
	}' unless defined(&write_can_lock);
    }
}
1;
